<?php
/**
 * WoWRoster.net WoWRoster
 *
 * Props to  zanix for the great fixs and menu buttons and so much editing
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    2.0.1 fix 8-14-08
 * @link       http://www.wowroster.net/Forums/viewforum/f=130.html
 * @package    Karma History addon for WoWRoster 2.0
 * Addon by Tennessee 
*/
if( !defined('IN_ROSTER') )
{
exit('Detected invalid access to this file!');
}

//---[ Update File Downloader ]-----------------------------
if( isset($_POST['send_file']) && !empty($_POST['send_file']) && !empty($_POST['data']) )
{
	$file = $_POST['data'];
	header('Content-Type: text/x-delimtext; name="'.$_POST['send_file'].'_log.txt"');
	header('Content-disposition: attachment; filename="'.$_POST['send_file'].'_log.txt"');
	// We need to stripslashes no matter what the setting of magic_quotes_gpc is
	echo stripslashes($file);
	exit;
}
$karmadb = new karmadb;
$script_filename = ('');
$parseMessages = '';
$updateMessages = '';
$updatePvPMessages = '';
$rosterUpdateMessages = '';
$htmlout = 1;
$filefields[] = 'ni_karma';
$uploadFound = false;
$uploadData = null;
require_once($addon['inc_dir'] . 'lua2phparray.php');
if( is_array($_FILES) && !empty($_FILES) )
{
	$uploadFound = true;
	$parseMessages = 'Parsing files'."<br />\n".'<ul>';
	// Loop through each posted file
	foreach( $_FILES as $filefield => $file )
	{
		if( !empty($file['name']) )
		{
			$file_name=$file_type='';
			list( $file_name, $file_type ) = explode( '.', $file['name'] );
			if( in_array(strtolower($file_name), $filefields) )
			{
				// Filefield is 1 of the kind we accept.
				if( $roster->config['authenticated_user'] )
				{
					// Get start of parse time
					$parse_starttime = explode(' ', microtime() );
					$parse_starttime = $parse_starttime[1] + $parse_starttime[0];
					// Parse the lua file into a php array that we can use
					$data = makePhpArray( $file['tmp_name'],$file_type );
					// Calculate parse time
					$parse_endtime = explode(' ', microtime() );
					$parse_endtime = $parse_endtime[1] + $parse_endtime[0];
					$parse_totaltime = round(($parse_endtime - $parse_starttime), 2);
					if( $data )
					{
						$parseMessages .= '<li>Parsed '.$file_name.' in '.$parse_totaltime.' seconds</li>'."\n";
					}
					else
					{
						$parseMessages .= '<li>Error while parsing '.$file_name.' after '.$parse_totaltime.' seconds</li>'."\n";
					}
					// If ni karma data is there, assign it to $uploadData['raiddata']
					if( isset($data['KarmaList']) )
					{
						$uploadData['raiddata'] = $data;
					}
					// Clear the $data variable
					unset($data);
				}
			}
			else
			{
				$parseMessages .= '<li>Did not accept '.$file['name'].'</li>'."\n";
			}
		}
		///////////////////////////////////////////////////////////////////////////////////
		unset ($filename);	// Done with the file, we don't need it anymore
	} ///////////////////////////////////////////////////////////////////////////////////
	$parseMessages .= '</ul>'."<br />\n";
}
//----- karma   -----//
// If the roster update password is sent and matches, and uploadData['raiddata'] is there, update the karmapoints
if( is_array($uploadData['raiddata']) && isset($_POST['password']) )
{
	if (	$roster->auth->getAuthorized($roster->config['gp_user_level']  ) )
	{
		$rosterUpdateMessages = processraiddata($uploadData['raiddata']);
	}
}

//----- Process Raid Data   karma -----//
function processraiddata($karmadata)
{
global $karmadb, $roster, $addon, $wordings, $messages;
	$karmadb->resetMessages();
	$karma_output = '';
	$output = '';
	foreach( array_keys( $karmadata['KarmaList'] ) as $database_name )
	{

    $database = $database_name;
    
    if( $database  == $database_name )
 		{
      $characters = $karmadata['KarmaList'][$database];
			$output .= "<strong>Using Database [<span class=\"blue\">$database</span>]</strong><br />\n";
			foreach( array_keys( $characters ) as $char_name)
	   		{
				$char = $characters[$char_name];
				$char_fullname = $char['fullname'];
				// Karma Detection, don't allow 0 karma
				if( $char['lifetime'] > 0 )
				{
				update_karma( $char_name, $char, $char_fullname, $database );
				$output .= "<ul>\n".$karmadb->getMessages()."</ul>\n";
				$karmadb->resetMessages();
				}
				else
				{
				$output .= "<span class=\"red\">NOT Updating character [$char_name]</span>Karma lifetime is  ".$char['lifetime']."<br />\n";
      }
			$output .= "<br />\n";
			}
		  update_karmalog  ($database);
    }
		else
		{  
			$output .= "<ul><li\n".$roster->locale->act['karma_nodatabaseor']."</li></ul><br />\n";
		}
	}
	return $output;
}
//----- End Process Raid Data   karma -----//
//----- karma   -----//

// Get SQL messages
$sqlstringout = $karmadb->getSQLStrings();
$errorstringout = $karmadb->getErrors();
/**
 * Make the html Upload page
 */                                                
 ?>
 <br />      
 <?php   
if( $htmlout )
{    
	// Construct the entire upload form

  if( $roster->auth->getAuthorized($roster->config['gp_user_level'] ) )
{
	$inputForm = "
                <form action=\"$script_filename\" enctype=\"multipart/form-data\" method=\"post\" onsubmit=\"submitonce(this)\">
".border('','start','')."
                  <table border=\"0\" class=\"border_color syellowborder\" cellspacing=\"1\" cellpadding=\"2\">
                    <tr>
                      <th class=\"thCornerL\" colspan=\"1\"><span class=\"title_text\">You are updateing Guild</span></th>
                      <th class=\"thCornerL\" colspan=\"1\">".$roster->data['guild_name']."</th>
                    </tr>
                    <tr>
                      <td class=\"row1\" align=\"left\"><b>Ni_Karma.lua</b></td>
                      <td class=\"row2\" align=\"left\"><input type=\"file\" accept=\"Ni_Karma.lua\" name=\"Ni_Karma\" /></td>
                    </tr>
                                       <tr>
                      <td class=\"row1\" align=\"left\"></td>
                      <td class=\"row2\" align=\"left\"><input type=\"hidden\" name=\"password\" /></td>
                    </tr>
                  </table>
".border('','end')."<br />
                  <input type=\"submit\" value=\"".$roster->locale->act['upload']."\" />";
	$inputForm .= "\n                </form>";
  } else {	
	$inputForm = "
                <form action=\"$script_filename\" enctype=\"multipart/form-data\" method=\"post\" onsubmit=\"submitonce(this)\">
".border('','start','')."
                  <table border=\"0\" class=\"border_color syellowborder\" cellspacing=\"1\" cellpadding=\"2\">
                    <tr>
                      <th class=\"thCornerL\" colspan=\"1\"><span class=\"title_text\">You are updateing Guild</span></th>
                      <th class=\"thCornerL\" colspan=\"1\">".$roster->data['guild_name']."</th>
                    </tr>
                    <tr>
                      <td class=\"row1\" align=\"left\"><b>Ni_Karma.lua</b></td>
                      <td class=\"row2\" align=\"left\"><input type=\"file\" accept=\"Ni_Karma.lua\" name=\"Ni_Karma\" /></td>
                    </tr>
                   <tr>
                      <td class=\"row1\" align=\"left\">Update password</td>
                      <td class=\"row2\" align=\"left\"><input type=\"password\" name=\"password\" /></td>
                    </tr>
                  </table>
".border('','end')."<br />
                  <input type=\"submit\" value=\"".$roster->locale->act['upload']."\" />";
	$inputForm .= "\n                </form>";
	}
	if( !$roster->config['authenticated_user'] )
	{
		print messagebox($roster->locale->act['update_disabled'],$roster->locale->act['update_page'],'sred');
	}
	else
	{
		if( $uploadFound )
		{
			// print the error messages
			if( !empty($errorstringout) )
			{
				print
				'<div id="errorCol" style="display:inline;">
					'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$roster->config['img_url']."plus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").'
					'.border('sred','end').'
				<div id="error" style="display:none">
				'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$roster->config['img_url']."minus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").
				$errorstringout.
				border('sred','end').
				'</div>';
				// Print the downloadable errors separately so we can generate a download
				print "<br />\n";
				print '<form method="post" action="'.$script_filename.'" name="post">'."\n";
				print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($errorstringout)).'" />'."\n";
				print '<input type="hidden" name="send_file" value="error" />'."\n";
				print '<input type="submit" name="download" value="Save Error Log" />'."\n";
				print '</form>';
				print "<br />\n";			}

			// Print the update messages
			print
				border('','start','Update Log').
				'<div style="font-size:10px;background-color:#1F1E1D;text-align:left;height:300px;width:550px;overflow:auto;">'.
					$parseMessages.
					$updateMessages.
					$updatePvPMessages.
					$rosterUpdateMessages.
				'</div>'.
				border('','end');
			// Print the downloadable messages separately so we can generate a download
			print "<br />\n";
			print '<form method="post" action="'.$script_filename.'" name="post">'."\n";
			print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($updateMessages.$updatePvPMessages.$rosterUpdateMessages)).'" />'."\n";
			print '<input type="hidden" name="send_file" value="update" />'."\n";
			print '<input type="submit" name="download" value="Save Update Log" />'."\n";
			print '</form>';
			print "<br />\n";
		}
		else
		{
			print $inputForm;
		}
	}
}
else	// Dont need the header and footer when responding to UU
{
	if( !$roster->config['authenticated_user'] )
	{
		print $roster->locale->act['update_disabled'];
	}
	else
	{
		if( $uploadFound )
		{
			// Strip all html tags out, then print
			print stripAllHtml(
					$parseMessages.
					$updateMessages.
					$updatePvPMessages.
					$rosterUpdateMessages
				);
		}
		else
		{
			// Weren't any files in the upload that correspond to anything in the array of filefields that we take.
			print $roster->locale->act['nofileUploaded'];
		}
	}
}
//---------------------------------------------------------------------------------------
function update_karmalog( $database )
	{ global $addon, $karmadb, $roster;
  
 $guildId = $roster->data['guild_id'];
 //$database = htmlspecialchars($_POST['database']);
$query = "SELECT `guild_id`, `karma_name` FROM `".$roster->db->table('addons_karmahistory_karmalog')."` WHERE `guild_id` = '$guildId' AND `karma_name` = '$database'";
$karma_log = $roster->db->query($query);
$karma_log_rows = $roster->db->num_rows($karma_log);
if(  $karma_log_rows > 0 )
{  
    
    $karmaId = $guildId;
		$karmadb->reset_values();
    $timeZoneOffset = $roster->config['localtimeoffset'];
    $update_time = date($roster->locale->act['phptimeformat'],mktime() + ($timeZoneOffset*3600)) . ' ' . $roster->config['timezone'];
    $karmadb->add_value( 'update_time', $update_time );
   	$querystr = "UPDATE `".$roster->db->table('addons_karmahistory_karmalog')."` SET ".$karmadb->assignstr." WHERE `guild_id` = '$karmaId' AND `karma_name` = '$database'";
		$roster->db->query($querystr) or die_quietly($roster->db->error(),'karmadb Error',basename(__FILE__).'<br />Function: '.(__FUNCTION__),__LINE__,$querystr);
    } else {
    $karmaId = $guildId;
  
    $karmadb->reset_values();
    $timeZoneOffset = $roster->config['localtimeoffset'];
    $update_time = date($roster->locale->act['phptimeformat'],mktime() + ($timeZoneOffset*3600)) . ' ' . $roster->config['timezone'];
		$karmadb->add_value( 'guild_id', $karmaId );
    $karmadb->add_value( 'karma_name', $database );
    $karmadb->add_value( 'update_time', $update_time );
    $karmadb->add_value( 'created_time', $update_time );
    $querystr = "INSERT INTO `".$roster->db->table('addons_karmahistory_karmalog')."` SET ".$karmadb->assignstr;
		$roster->db->query($querystr) or die_quietly($roster->db->error(),'karmadb Error',basename(__FILE__).'<br />Function: '.(__FUNCTION__),__LINE__,$querystr);
	}
	
}
//------- Update Karma--------------//
function update_karma( $name, $data, $char_fullname, $database )
	{ global $addon, $karmadb, $roster;
   $database = $database;
  $guildId = $roster->data['guild_id']; 
	$name_escape = ( $char_fullname );
		$querystr = "SELECT `member_id` FROM `".$roster->db->table('members')."` WHERE `name` = '$name_escape' AND `guild_id` = '$guildId'";
		$result = $roster->db->query($querystr);
	if( !$result )
		{
			$roster->db->setError('Cannot select member_id for Character Data',$roster->db->error());
			return;
		}
		$memberInfo = $karmadb->fetch_assoc( $result );
		$karmadb->closeQuery($result);
		if ($memberInfo)
		{
			$memberId = $memberInfo['member_id'];
		}
	else
		{  // Remove the members who were not in this list
	   	remove_karma_members($name);
			$karmadb->setMessage('<li><strong><span class="red">'.$name.' is not in the list of guild members so their data will not be inserted.</span></strong></li>');
      return;
		}
  if ($addon['config']['clearplayerdata'] == 1)
     {
       $querystr = "DELETE FROM `".$roster->db->table('addons_karmahistory_karma')."` WHERE `member_id` = '$memberId'";
			if( !$roster->db->query($querystr) )
			{
				$roster->db->setError('Player could not be deleted',$roster->db->error());
				return;
			}
       $karmadb->setMessage('<li><strong>Player '.$name.' has been reset</strong></li>');
      }
    //$database = htmlspecialchars($_POST['database']);  
		$querystr = "SELECT `member_id` FROM `".$roster->db->table('addons_karmahistory_karma')."` WHERE `member_id` = '$memberId' AND `karma_name` = '$database'";
		$result = $roster->db->query($querystr);
	if( !$result )
		{
		$roster->db->setError('Cannot select member_id for Karma Data',$roster->db->error());
	return;
		}
		$update = $karmadb->num_rows( $result ) == 1;
		$karmadb->closeQuery($result);
		$karmadb->reset_values();
		$karmadb->add_value( 'points', $data['points'] );
		$karmadb->add_value( 'lifetime', $data['lifetime'] );
		$karmadb->add_value( 'lastadd', $data['lastadd'] );
	if( $update )
		{
		$querystr = "UPDATE `".$roster->db->table('addons_karmahistory_karma')."` SET ".$karmadb->assignstr." WHERE `member_id` = '$memberId' AND `karma_name` = '$database'";
		$karmadb->setMessage('<li> '.$name.' <span class="yellow"> - Updated</span></li>');
		$result = $roster->db->query($querystr);
    $karmadb->membersupdated++;
	if( !$result )
		{
	 $roster->db->setError('Cannot update Character\'s Karma Data',$roster->db->error());
	return;
	  }
	  }
else
		{
	if( !empty($memberId) )
	  $karmadb->add_value( 'guild_id', $guildId );
	  $karmadb->add_value( 'karma_name', $database );
		$karmadb->add_value( 'member_id', $memberId );
		$karmadb->add_value( 'class', $data['class'] );
		$karmadb->add_value( 'fullname', $data['fullname'] );
		$karmadb->add_value( 'name', $name );
		$querystr = "INSERT INTO `".$roster->db->table('addons_karmahistory_karma')."` SET ".$karmadb->assignstr;
		$karmadb->setMessage('<li><strong><span class="green">Added Player </span> '.$name.' </strong></li>');
		$result = $roster->db->query($querystr);
		$karmadb->membersadded++;
	if( !$result )
    {
	  $roster->db->setError('Cannot Add Character\'s Karma Data',$roster->db->error());
	return;
		}
	 }
	 do_karma( $data, $memberId, $name, $database );
  }
//------END update_karma--//
//----- Do Karma items   -----//
function do_karma( $data, $memberId, $name, $database )
	{ global $addon, $karmadb, $roster;
	   $data['Locale'] = '';
	if ($addon['config']['clearitemdata'] == 1)
     {
       $querystr = "DELETE FROM `".$roster->db->table('addons_karmahistory_karmaitems')."` WHERE `member_id` = '$memberId'";
			if( !$roster->db->query($querystr) )
			{
				$roster->db->setError('items could not be deleted',$roster->db->error());
				return;
			}
       $karmadb->setMessage('<li><strong>All items for '.$data['fullname'].' have been reset</strong></li>');
      }
      
		$playersdata = $data;
		if( !empty($playersdata) && is_array($playersdata) )
		{
		$karmadb->setMessage('<li><strong><span class="yellow">Updating Karma items for '.$data['fullname'].'</span></strong></li>');
		$karmadb->setMessage('<li><span class="green">');
			foreach( array_keys( $playersdata ) as  $events )
			{
				$eventdata = $playersdata[$events];
				if( is_null($eventdata) || !is_array($eventdata) || empty($eventdata) )
				{
					continue;
				}
			if ( $eventdata['type'] == 'I' )
         {
         $ctr=0;
         $item_id = '';
         $reasonsname = '';
		     preg_match_all('/[^|]+/i', $eventdata['reason'], $words);
         preg_match_all('/[^:]+/i', $words[0][1], $item);     // $words[0][0]; = color of the item
			   $reasonsname .= substr($words[0][2], 2, -1);     //name of the item
         $item_id .= $item[0][1];                        // item number
		     $itemd = $item_id;
		     $item_name = $reasonsname;
				 }
         elseif ($eventdata['type'] == 'P')
          {
          $itemd = $eventdata['reason'];
          $item_name = '';
          }
			    $item = make_karma( $eventdata, $memberId, $name, $events, $itemd, $item_name, $database );
			    //$database = htmlspecialchars($_POST['database']);

   $querystr = "SELECT `karma_name` FROM `".$roster->db->table('addons_karmahistory_karmaitems')."` WHERE `karma_name` = '$database' AND `member_id` = '$memberId' AND `item_slot` = '".$item['item_slot']."'";
	 $result = $roster->db->query($querystr);
	 if( !$result )
	     	{
		    $roster->db->setError('Cannot select member_id for Karma Data',$roster->db->error());
     	return;
	     	}
        $update = $karmadb->num_rows( $result );
		    $karmadb->closeQuery($result);
	     	$karmadb->reset_values();
	     	if( $update )
		      {
		      //where not gona do anything
          }
	   else
         {
          $karmadb->setMessage($events);
				insert_karma($data, $item, $data['Locale'], $database );
			}
     }
		}
		else
		{
			$karmadb->setMessage('<li>No Karma Data</li>');
		}
		$karmadb->setMessage('</span>'.$roster->locale->act['doneupdateing'].$data['fullname'].'</li>');
	}
//----- End Do Karma items   -----//
//-----  Karma Make items  -----//
function make_karma( $item_data, $memberId, $name, $events, $itemd, $item_name )
	{    global $karmadb, $roster;
		$item = array();
    $item['item_slot'] = $events;
		$item['member_id'] = $memberId;
		$item['item_parent'] = $name;
		$item['value'] = $item_data['value'];
		$item['type'] = $item_data['type'];
		$item['reason'] = $itemd;
		$item['item_name'] = $item_name;
		$item['DT'] = $item_data['DT'];
		$item['shortdt'] = $item_data['DT'];
		return $item;
	}
//----- End   Make items  -----//
//-----   Insert items  -----//
function insert_karma($data, $item, $locale, $database )
	{    global $karmadb, $roster;

  $guildId = $roster->data['guild_id'];
    //$database = htmlspecialchars($_POST['database']);
		$karmadb->reset_values();
	  $karmadb->add_value('karma_name', $database );
	  $karmadb->add_value('member_id', $item['member_id'] );
		$karmadb->add_value('item_slot', $item['item_slot'] );
		$karmadb->add_value('item_parent', $item['item_parent'] );
		$karmadb->add_value('value', $item['value'] );
		$karmadb->add_value('type', $item['type'] );
		$karmadb->add_value('reason', $item['reason'] );
		$karmadb->add_value('item_name', $item['item_name'] );
		$karmadb->add_value('DT', $item['DT'] );
		$karmadb->add_value('shortdt', $item['shortdt'] );
		$karmadb->add_value('class', $data['class'] );
		$karmadb->add_value('fullname', $data['fullname'] );
		$karmadb->add_value( 'guild_id', $guildId );
		$querystr = "INSERT INTO `".$roster->db->table('addons_karmahistory_karmaitems')."` SET ".$karmadb->assignstr;
		$result = $roster->db->query($querystr);
		if( !$result )
		{
			$roster->db->setError('Item ['.$item.'] could not be inserted',$roster->db->error());
		}
	}
//-----   Insert items  -----//
//---------remove members--------------------------------//
function remove_karma_members($name)
	{    global $karmadb, $roster;

  $guildId = $roster->data['guild_id'];	
	
		$querystr = "SELECT member_id FROM `".$roster->db->table('addons_karmahistory_karma')."` WHERE `fullname` = '$name' And `guild_id` = '$guildId'";
		$result = $roster->db->query($querystr) or die_quietly($roster->db->error(),'Database Error',basename(__FILE__),__LINE__,$querystr);

		$num = $karmadb->num_rows($result);
		$inClause = '';
		if ($num > 0)
		{
			while ( $row = $karmadb->fetch_array($result) )
			{
			if ($inClause != '')
					$inClause .= ',';
				$inClause .= $row[0];
				$karmadb->setMessage('<li><span class="red">[</span> '.$row[0].' <span class="red">] - Deleted</span></li>');
				$karmadb->setMemberLog($row,0);
			}
			$karmadb->setMessage('<li><span class="red">Deleted '.$num.' member'.($num > 1 ? 's' : '').'</span>');
			$karmadb->setMessage('<ul>');
			// now that we have our inclause, time to do some deletes
			deleteMembers($inClause);
			$karmadb->setMessage('</ul></li>');
		}
		$karmadb->closeQuery($result);
	}
function deleteMembers( $inClause )
	{      global $karmadb, $roster;
		$karmadb->setMessage('<li>');
		$karmadb->setMessage('Character Data..');
		$querystr = "DELETE FROM `".$roster->db->table('addons_karmahistory_karma')."` WHERE `member_id` IN ($inClause)";
		if( !$roster->db->query($querystr) )
		{
			$roster->db->setError('Member Data could not be deleted',$roster->db->error());
		}
		$karmadb->setMessage('Items..');
		$querystr = "DELETE FROM `".$roster->db->table('addons_karmahistory_karmaitems')."` WHERE `member_id` IN ($inClause)";
		if( !$roster->db->query($querystr) )
		{
			$roster->db->setError('Items Data could not be deleted',$roster->db->error());
		}
    $karmadb->setMessage('</li>');
	}
//------- end remove members--------------------------------//
class karmadb
{
	var $db;			// Database resource id
	var $assignstr;		// Data to be inserted/updated to the db
	var $sqldebug;		//
	var $sqlstrings;	// Array of SQL strings passed to query()
	var $messages;		// Array of stored messages
	var $errors;		// Array of stored error messages
	var $membersadded=0;
	var $membersupdated=0;
	var $membersremoved=0;

	function error()
	{
		$result = @mysql_errno().': '.mysql_error();
		return $result;
	}

	function getrow( $result )
	{
		global $roster;

		if (!$result && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		return mysql_fetch_assoc( $result );
	}

	function fetch_assoc( $result )
	{
		global $roster;

		if (!$result && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		return mysql_fetch_assoc( $result );
	}

	function fetch_array( $result )
	{
		global $roster;

		if (!$result && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		return mysql_fetch_array( $result );
	}

	function fetch_row( $result )
	{
		global $roster;

		if (!$result && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		return mysql_fetch_row( $result );
	}

	function num_rows( $result )
	{
		global $roster;

		if (!$result && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		return mysql_num_rows( $result );
	}

	function escape( $string )
	{
		if( version_compare( phpversion(), '4.3.0', '>' ) )
			return mysql_real_escape_string( $string );
		else
			return mysql_escape_string( $string );
	}

	function closeDb()
	{
		// Closing connection
		if( is_resource($this->db) )
			return @mysql_close($this->db);
	}

	function closeQuery($query_id)
	{
		global $roster;

		if (!$query_id && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		// Free resultset
		return @mysql_free_result($query_id);
	}

	function free_result($query_id)
	{
		global $roster;

		if (!$query_id && $roster->config['debug_mode'])
		{
			die_quietly('Invalid query result passed','Roster DB Layer');
		}

		// Free resultset
		return @mysql_free_result($query_id);
	}

	function setSQLDebug($sqldebug)
	{
		$this->sqldebug = $sqldebug;
	}

	function getSQLStrings()
	{
		$sqlstrings = $this->sqlstrings;
		$output = '';
		if( is_array($sqlstrings) )
		{
			foreach($sqlstrings as $sql)
			{
				$output .= "$sql\n";
			}
		}
		return $output;
	}

	function setMessage($message)
	{
		$this->messages[] = $message;
	}

	function getMessages()
	{
		$messages = $this->messages;
		$output = '';
		if( is_array($messages) )
		{
			foreach($messages as $message)
			{
				$output .= "$message\n";
			}
		}
		return $output;
	}

	function resetMessages()
	{
		$this->messages = null;
	}

	function setError($message,$error)
	{
		$this->errors[] = array($message=>$error);
	}

	function getErrors( $mode='' )
	{
		if( $mode == 'a')
		{
			return $this->errors;
		}

		$output = '';

		$errors = $this->errors;
		if( is_array($errors) )
		{
			$output = '<table width="100%" class="bodyline" cellspacing="0">';
			$steps = 0;
			foreach($errors as $errorArray)
			{
				foreach ($errorArray as $message => $error)
				{
					if ( $steps == 1 )
						$steps = 2;
					else
						$steps = 1;

					$output .= "<tr><td class=\"membersRowRight$steps\">$message<br />\n".
						"$error</td></tr>\n";
				}
			}
			$output .= '</table>';
		}
		return $output;
	}

	function reset_values()
	{
		$this->assignstr = '';
	}

	function add_value( $row_name, $row_data )
	{
		if( $this->assignstr != '' )
			$this->assignstr .= ',';

		$row_data = "'" . $this->escape( $row_data ) . "'";

		$this->assignstr .= " `$row_name` = $row_data";
	}

	function setMemberLog( $data , $type )
	{
		if ( is_array($data) )
		{
			switch ($type)
			{
				case 'del':
				case 'rem':
				case 0:
					$this->membersremoved++;
					//$this->updateMemberlog($data,0);
					break;

				case 'add':
				case 'new':
				case 1:
					$this->membersadded++;
					//$this->updateMemberlog($data,1);
					break;
			}
		}
	}
 
} //-END CLASS